#pragma once

#include "afxtempl.h"

class _declspec (dllimport) CBorder
{
public:
	CBorder(void);
	~CBorder(void);
	// This field defines colour of a border
	OLE_COLOR m_Color;
	
	// Width of the border sides
	int m_LeftWidth;
	int m_RightWidth;
	int m_TopWidth;
	int m_BottomWidth;
	
	// constructor
	CBorder(OLE_COLOR Color, int LeftWidth, int TopWidth, int RightWidth, int BottomWidth);
};

typedef CArray<CBorder,CBorder> CBorderArray;

#define NCS_CTRL_OWN_BORDER		(1<<4)
#define NCS_CTRL_CLEAR_COLOR	(1<<7)

// CPanel

class _declspec (dllimport) CPanel : public CWnd
{
	DECLARE_DYNAMIC(CPanel)

public:

	CRect m_AbsPosition;

	CPanel(BOOL bAutoDel = FALSE);
	virtual ~CPanel();

	void SetNcsFlag(DWORD dwFlag, BOOL bNotify = TRUE);
	void ClearNcsFlag(DWORD dwFlag, bool bNotify = TRUE);
	BOOL IsNcsFlag(DWORD dwFlag);
	virtual void SetBorderLayer(int nLayer = 0, int nLeft = 1, int nTop = 1, int nRight = 1, int nBottom = 1, OLE_COLOR crColor = 0);
	static void SetCommonBorderLayer(int nLayer = 0, int nLeft = 1, int nTop = 1, int nRight = 1, int nBottom = 1, OLE_COLOR crColor = 0);
	virtual OLE_COLOR GetBorderLayer(int nLayer, int& LeftWidth, int& TopWidth, int& RightWidth, int& BottomWidth);
	void DeleteBorderLayer(int nLayer = -1);
	int GetNumBorderLayers(void);
	static void DeleteCommonBorderLayer(int nLayer = -1);
	static void Init(void);
	virtual void OnRefresh(void);
	COLORREF GetColorRef(OLE_COLOR Color, HPALETTE hpal = NULL);
	virtual BOOL Create(CWnd* pParent, CRect Rect = CRect (0, 0, 0, 0), UINT nID = -1);
	CRect DrawBorder(CDC* pdc, CRect rcBound, CRect rcBound2);
	static BOOL RegisterWndClass(HINSTANCE hInstance);
	void Apply3DStyle(UINT nBorderType = 0, bool bDeleteBorders = FALSE);
	BOOL SubclassDlgItem(UINT nID, CWnd* pParent);
	virtual void PostNcDestroy(void);

protected:

	DECLARE_MESSAGE_MAP()

	DWORD m_NcsFlag;
	CBorderArray m_Border;
	BOOL m_bAutoDel;

	virtual COLORREF GetTranslateColor(OLE_COLOR Color, CDC* pDC);
	virtual void OnFlagChanged(DWORD dwFlag);
	static CBorderArray m_CommonBorder;
	afx_msg void OnNcPaint();
	afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSysColorChange();
	static LRESULT CALLBACK AFX_EXPORT PanelWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
	OLE_COLOR GetWindowsColor(int nIndex);

private:
};


